#ifndef SYSTEM_TYPES_H
#define SYSTEM_TYPES_H

/*
**  types.h
**
**  (C) Copyright 1996-2002 Rocklyte Systems.
**      All Rights Reserved.
*/

/*****************************************************************************
** Standard data types.
*/

#ifndef XMD_H
#ifndef _WINDEF_
typedef char               BYTE;     /* Signed 8-bit quantity */
#endif
#endif

typedef unsigned char      UBYTE;    /* Unsigned 8-bit quantity */
typedef unsigned short     UWORD;    /* Unsigned 16-bit quantity */

#ifndef _WINDEF_
typedef short              WORD;     /* Signed 16-bit quantity */
typedef int                LONG;     /* Signed 32-bit quantity */
typedef unsigned int       ULONG;    /* Unsigned 32-bit quantity */
#endif

typedef float              FLOAT;    /* Signed 32-bit floating point */
typedef double             DOUBLE;   /* Signed 64-bit floating point */

/* If your compiler does not accept 'long long' definitions, try changing the
** LARGE type setting to __int64.
*/

#if defined(_MSC_VER)
typedef __int64            LARGE;
#else
typedef long long          LARGE;    /* Signed 64-bit quantity */
#endif

#ifdef _WIN32
typedef void * WINHANDLE;
#else
typedef int WINHANDLE;
#endif

/*****************************************************************************
** Pointer types.
*/

typedef void *          APTR;      /* 32-bit untyped pointer */
typedef unsigned char * STRING;    /* string pointer (NULL terminated) */
typedef struct Head *   OBJECTPTR; /* Object pointer */
typedef void *          OBJECT;    /* Object pointer */

/*****************************************************************************
** Pandora specific types.
*/

#undef ERROR
#undef OBJECTID
typedef LONG ERROR;    /* Standard error code */
typedef LONG OBJECTID; /* 32-bit object ID */
typedef LONG MEMORYID; /* 32-bit memory ID */
typedef LONG STRINGID; /* 32-bit memory ID */
typedef LONG CLASSID;  /* 32-bit class ID */
typedef LONG ACTIONID; /* 32-bit action ID */
typedef LONG FIELD;    /* 32-bit field ID */

/*****************************************************************************
** Special keyword definitions.
*/

#undef NULL
#define NULL 0

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef IS
#define IS ==
#endif

#ifndef AND
#define AND &&
#endif

#ifndef OR
#define OR ||
#endif

#ifndef YES
#define YES TRUE
#endif

#ifndef NO
#define NO FALSE
#endif

#endif  /* SYSTEM_TYPES_H */
